var APIBase = require("../../api.base");
var system = require("../../../system");
class AccessAuthAPI extends APIBase {
    constructor() {
        super();
        this.opPlatformUtils = system.getObject("util.businessManager.opPlatformUtils");
    }

    async getTokenByHosts(pobj, qobj, req) {
        var app_hosts = pobj.app_hosts || "";
        if (!app_hosts) {
            return system.getResult(null, "app_hosts can not be empty ！");
        }
        var result = await this.opPlatformUtils.getReqTokenByHosts(app_hosts);
        return result;
    }

    async getVerifyCodeByMoblie(pobj, qobj, req) {
        if (!pobj.actionBody.mobile) {
            return system.getResult(null, "actionBody.mobile can not be empty ！");
        }
        var result = await this.opPlatformUtils.fetchVCode(pobj.actionBody.mobile, pobj.appInfo.uapp_key, pobj.appInfo.uapp_secret);
        return result;
    }

    async loginUserByChannelUserId(pobj, qobj, req) {
        if (!pobj.actionBody.channelUserId) {
            return system.getResult(null, "actionBody.channelUserId can not be empty ！");
        }
        var result = await this.opPlatformUtils.getReqUserPinByChannelUserId(pobj);
        return result;
    }

    async login(pobj, qobj, req) {
        if (!pobj.actionBody.userName) {
            return system.getResult(null, "actionBody.userName can not be empty ！");
        }
        if (!pobj.actionBody.password) {
            return system.getResult(null, "actionBody.password can not be empty ！");
        }
        var result = await this.opPlatformUtils.getReqUserPinByLgoin(pobj);
        return result;
    }

    async loginByVerifyCode(pobj, qobj, req) {
        if (!pobj.actionBody.mobile) {
            return system.getResult(null, "actionBody.mobile can not be empty ！");
        }
        if (!pobj.actionBody.vcode) {
            return system.getResult(null, "actionBody.vcode can not be empty ！");
        }
        var result = await this.opPlatformUtils.getReqUserPinByLgoinVcode(pobj);
        return result;
    }
    async modiPasswordByMobile(pobj, qobj, req) {
        var actionBody = pobj.actionBody;
        if (!actionBody.mobile) {
            return system.getResult(null, "actionBody.mobile can not be empty ！");
        }
        if (!actionBody.vcode) {
            return system.getResult(null, "actionBody.vcode can not be empty ！");
        }
        if (!actionBody.newPwd) {
            return system.getResult(null, "actionBody.newPwd can not be empty ！");
        }
        var result = await this.opPlatformUtils.putUserPwdByMobile(pobj, actionBody);
        return result;
    }

}
module.exports = AccessAuthAPI;