const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");

class ProductService extends ServiceBase {
  constructor() {
    super("dbproduct", ServiceBase.getDaoName(ProductService));
    this.productpriceDao = system.getObject("db.dbproduct.productpriceDao");
  }
  /**
   * 获取产品详情
   * @param {*} channelItemCode 渠道产品码
   * @param {*} uappid 渠道id
   */
  async getProductDetailByCode(channelItemCode, uappid) {
    var sql = "select * from v_product where uapp_id=" + uappid + " and channel_item_code='" + channelItemCode + "'";
    var tmpResult = await this.customQuery(sql);
    if (tmpResult && tmpResult.length > 0) {
      for (var i = 0; i < tmpResult.length; i++) {
        var pro = tmpResult[i];
        if (pro.id) {
          var ppList = await this.productpriceDao.model.findAll({
            where: { product_id: pro.id },
            attributes: ["price", "supply_price", "service_charge", "public_expense", "is_default", "price_type", "price_type_name",
              "sort", "price_desc", "min_qty", "max_qty"
            ],
            raw: true
          });
          pro.productPriceList = ppList;
        }

      }
    }
    return system.getResultSuccess(tmpResult);
  }

  /**
   * 通过产品类别编码获取产品列表    
   * @param {*} actionBody 
   */
  async findByTypeCode(actionBody, appInfo) {
    var sql = "select * from v_product where uapp_id=" + appInfo.uapp_id + " and type_code='" + actionBody.typeCode + "'";
    var tmpResult = await this.customQuery(sql);
    return system.getResultSuccess(tmpResult);
  }
  /**
   * 通过产品大类编码获取产品列表
   * @param {*} actionBody 
   */
  async findByTypeOneCode(actionBody, appInfo) {
    var sql = "select * from v_product where uapp_id=" + appInfo.uapp_id + " and p_type_code='" + actionBody.typeOneCode + "'";
    var tmpResult = await this.customQuery(sql);
    return system.getResultSuccess(tmpResult);
  }
}
module.exports = ProductService;
